searchData={"content_type":"text/markdown","items":[{"doc":"Automatically sets the SCENIC_LOCAL_TARGET for the Makefile","ref":"Mix.Tasks.Compile.ScenicDriverLocal.html","title":"mix compile.scenic_driver_local","type":"task"},{"doc":"","ref":"Mix.Tasks.Compile.ScenicDriverLocal.html#run/1","title":"Mix.Tasks.Compile.ScenicDriverLocal.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Compile.ScenicDriverLocal.html#target/0","title":"Mix.Tasks.Compile.ScenicDriverLocal.target/0","type":"function"},{"doc":"Documentation for `Scenic.Driver.Local`.\n\nSupported config options:\n* `:name`\n\n* `:limit_ms` (`t:non_neg_integer/0`) - The default value is `29`.\n\n* `:layer` (`t:integer/0`) - The default value is `0`.\n\n* `:opacity` (`t:integer/0`) - The default value is `255`.\n\n* `:debug` (`t:boolean/0`) - The default value is `false`.\n\n* `:debugger` (`t:String.t/0`) - The default value is `\"\"`.\n\n* `:debug_fps` (`t:integer/0`) - The default value is `0`.\n\n* `:antialias` (`t:boolean/0`) - The default value is `true`.\n\n* `:calibration` - The default value is `[]`.\n\n* `:position` (`t:keyword/0`) - The default value is `[]`.\n\n  * `:scaled` (`t:boolean/0`) - The default value is `false`.\n\n  * `:centered` (`t:boolean/0`) - The default value is `false`.\n\n  * `:orientation` - The default value is `:normal`.\n\n* `:window` (`t:keyword/0`) - The default value is `[]`.\n\n  * `:title` (`t:String.t/0`) - The default value is `\"Scenic Window\"`.\n\n  * `:resizeable` (`t:boolean/0`) - The default value is `false`.\n\n* `:cursor` (`t:boolean/0`) - The default value is `false`.\n\n* `:key_map` (`t:atom/0`) - The default value is `Scenic.KeyMap.USEnglish`.\n\n* `:on_close` - The default value is `:restart`.\n\n* `:input_blacklist` (list of `t:String.t/0`) - The default value is `[]`.","ref":"Scenic.Driver.Local.html","title":"Scenic.Driver.Local","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Driver.Local.html#child_spec/1","title":"Scenic.Driver.Local.child_spec/1","type":"function"},{"doc":"","ref":"Scenic.Driver.Local.html#hide_cursor/1","title":"Scenic.Driver.Local.hide_cursor/1","type":"function"},{"doc":"","ref":"Scenic.Driver.Local.html#position/2","title":"Scenic.Driver.Local.position/2","type":"function"},{"doc":"","ref":"Scenic.Driver.Local.html#set_cursor/2","title":"Scenic.Driver.Local.set_cursor/2","type":"function"},{"doc":"","ref":"Scenic.Driver.Local.html#show_cursor/1","title":"Scenic.Driver.Local.show_cursor/1","type":"function"},{"doc":"","ref":"Scenic.Driver.Local.html#validate_calibration/1","title":"Scenic.Driver.Local.validate_calibration/1","type":"function"},{"doc":"Experimental library of cursors that you can use with a Nerves project.\n\nThe `:cursor` option must be set to `true` in the driver config.\n\nNote: the implementation of cursors is pretty naive and will be much more\nperformant in the future.\n\nIn fact, I would really recommend using cursors at this point except to test\nit out and provide feedback...","ref":"Scenic.Driver.Local.Cursor.html","title":"Scenic.Driver.Local.Cursor","type":"module"},{"doc":"","ref":"Scenic.Driver.Local.Cursor.html#t:t/0","title":"Scenic.Driver.Local.Cursor.t/0","type":"type"},{"doc":"Behaviour and support for mapping key press/repeat input to codepoint strings.","ref":"Scenic.KeyMap.USEnglish.html","title":"Scenic.KeyMap.USEnglish","type":"module"},{"doc":"# Scenic.Driver.Local\n\nThis is the main \"local\" renderer for Scenic applications.\n\nIf you are on a Mac/PC/Linux machine, or building under Nerves, then this is the driver to use to render on the screen connected to the computer Scenic is running on.\n\nThis driver replaces both `:scenic_driver_glfw` and `:scenic_driver_nerves_rpi` going forward for Scenic v0.11 and up.","ref":"overview.html","title":"Scenic.Driver.Local","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `scenic_driver_local` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:scenic_driver_local, \"~> 0.11.0-beta.0\"}\n  ]\nend\n```","ref":"overview.html#installation","title":"Installation - Scenic.Driver.Local","type":"extras"},{"doc":"The configuration options for `scenic_driver_local` are slightly different from `scenic_driver_glfw`, so you may need to do a little work to bring over your options. Namely, options that pertain to the window under `scenic_driver_glfw`, aren't relevant to any Nerves build. So they are now under the `:window` option.\n\nExample:\n\n```elixir\n[\n  module: Scenic.Driver.Local,\n  window: [title: \"Local Window\", resizeable: true]\n]\n```\n\nThere are quite a few new options as well. It uses `NimbleOptions` to confirm them, so look at the `Scenic.Driver.Local` module for details.","ref":"overview.html#configuration","title":"Configuration - Scenic.Driver.Local","type":"extras"},{"doc":"This driver does it's best to figure out what underlying graphics technology to use depending on whhat your MIX_TARGET is set to.\n\nFor example, for apps running on a Mac/PC/Linux, it is usually set to `host`, which causes the driver to use `glfw` as the underlying tech.\n\nIf you are building for Nerves, it will use `bcm` (Broadcom Manager) for any of `rpi`, `rpi0`, `rip2`, `rpi3`, and `rpi3a`.","ref":"overview.html#targets","title":"Targets - Scenic.Driver.Local","type":"extras"},{"doc":"`Scenic.Driver.Local` uses `drm` (Direct Render Manager) for the `rpi4` and `bbb`. It currently renders on the rpi4, but is __very slow__. I haven't figured out why yet and if anyone wants to dig in, that would be appreciated. It should be really fast, so is probably a hardware configuration issue.\n\nThe `bbb` doesn't work (is close in theory??) as the Nerves `bbb` system doesn't have the needed graphics support in it yet. There are others who have gotten SGX support working for the `bbb` and I could use some help from them.","ref":"overview.html#nerves-rpi4-bbb-need-work-help","title":"Nerves rpi4 & bbb Need Work / Help - Scenic.Driver.Local","type":"extras"},{"doc":"For custom systems (example - figuring out how to add SGX support to the `bbb`) You will need to set SCENIC_LOCAL_TARGET manually. You may also need to set the SCENIC_LOCAL_GL as well.\n\nexample in your command line\n\n```\nexport SCENIC_LOCAL_TARGET=drm\nexport SCENIC_LOCAL_GL=gles3\n```\n\nThese options may change, especially as we sort out the issues on the `rpi4` and the `bbb`. If SCENIC_LOCAL_TARGET isn't set, then look in the build output for instructions.","ref":"overview.html#custom-nerves-targets","title":"Custom Nerves Targets - Scenic.Driver.Local","type":"extras"},{"doc":"This driver requires Scenic v0.11 or up.","ref":"overview.html#prerequisites","title":"Prerequisites - Scenic.Driver.Local","type":"extras"},{"doc":"The easiest way to install on MacOS is to use Homebrew. Just run the following in a terminal:\n\n```bash\nbrew update\nbrew install glfw3 glew pkg-config\n```\n\n\nOnce these components have been installed, you should be able to build the `scenic_driver_glfw` driver.","ref":"overview.html#installing-on-macos","title":"Installing on MacOS - Scenic.Driver.Local","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:\n\n```bash\napt-get update\napt-get install pkgconf libglfw3 libglfw3-dev libglew2.0 libglew-dev\n```\n\nOnce these components have been installed, you should be able to build the `scenic_driver_glfw` driver.","ref":"overview.html#installing-on-ubuntu-18-04","title":"Installing on Ubuntu 18.04 - Scenic.Driver.Local","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:\n\n```bash\napt-get update\napt-get install pkgconf libglfw3 libglfw3-dev libglew2.1 libglew-dev\n```\n\nOnce these components have been installed, you should be able to build the `scenic_driver_glfw` driver.","ref":"overview.html#installing-on-ubuntu-20-04","title":"Installing on Ubuntu 20.04 - Scenic.Driver.Local","type":"extras"},{"doc":"The easiest way to install on Arch Linux is to use pacman. Just run the following:\n\n\n```bash\npacman -Syu\nsudo pacman -S glfw-x11 glew\n```\n\nIf you're using Wayland, you'll probably need `glfw-wayland` instead of `glfw-x11` and `glew-wayland` instead of `glew`","ref":"overview.html#installing-on-arch-linux","title":"Installing on Arch Linux - Scenic.Driver.Local","type":"extras"},{"doc":"This has not been tested yet and probably needs work in the makefile!!!!!\nIf you are interested in helping out, that would be welcome.\n\nFirst, make sure to have installed Visual Studio with its \"Desktop development with C++\" package.\n\nNext, you need to download the Windows binaries for [GLFW](https://www.glfw.org/download.html) and [GLEW](http://glew.sourceforge.net/index.html) manually.\n\nLocate your Visual Studio installation directory. Two folders will be required for the next steps:\n\n* The **Include** folder: `{Visual Studio Path}\\VC\\Tools\\MSVC\\{version number}\\include`\n* The **Lib** folder: `{Visual Studio Path}\\VC\\Tools\\MSVC\\{version number}\\lib\\x64`\n\nOpen the GLFW package you downloaded. Extract the contents of the packaged `include` folder to your Visual Studio **Include** folder. Next to the `include` folder, you'll also find several `lib-vc20xx` folders. Select the closest match to your Visual Studio version and extract the contents to your **Lib** folder.\n\nLastly, install the GLEW package. Find the packaged `include` folder and extract its contents to your **Include** folder as well. You should now have two new folders in your **Include** folder: `GL` and `GLFW`. Now navigate to `lib\\Release\\x64` in the GLEW package. Copy all `*.lib` files to your **Lib** folder. Finally, navigate to `bin\\Release\\x64` and copy `glew32.dll` to your `Windows\\system32` folder.\n\nOnce these components have been installed, you should be able to build the `scenic_driver_glfw` driver.","ref":"overview.html#installing-on-windows","title":"Installing on Windows - Scenic.Driver.Local","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}